import 'package:adeptutils/src/extendables/jsonable.dart';

class JMapEntry<K, V> extends Jsonable<JMapEntry> {
  /// The key of the entry.
  final K key;

  /// The value associated to [key] in the map.
  final V value;

  /// Creates an entry with [key] and [value].
  JMapEntry(this.key, this.value);

  @override
  String toString() => 'MapEntry($key: $value)';

  @override
  Map<String, dynamic> toJson() => {
        'key': key,
        'value': value,
      };

  @override
  JMapEntry? fromJsonMap(Map<String, dynamic>? json) =>
      json == null ? null : JMapEntry.fromJson(json);

  factory JMapEntry.fromJson(Map<String, dynamic> json) =>
      JMapEntry(json['key'], json['value']);
}
