import 'dart:collection';

class ListStack<E> extends Iterable<E> {
  ListQueue<E> _list = ListQueue();

  /// check if the stack is empty.
  @override
  bool get isEmpty => _list.isEmpty;

  /// check if the stack is not empty.
  @override
  bool get isNotEmpty => _list.isNotEmpty;

  /// check if the stack is not empty.
  int get size => _list.length;

  /// push all elements in the top of the stack.
  void pushAll(Iterable<E> elements) {
    for (var element in elements) {
      push(element);
    }
  }

  /// add all elements exactly as it is in elements iterable.
  void addAll(Iterable<E> elements) {
    _list.addAll(elements);
  }

  /// push element in top of the stack.
  E push(E item) {
    _list.addLast(item);
    return item;
  }

  /// get the top of the stack and delete it.
  E pop() {
    E item = _list.last;
    _list.removeLast();
    return item;
  }

  /// get the top of the stack without deleting it.
  E peek() {
    return _list.last;
  }

  void clear() {
    _list = ListQueue();
  }

  @override
  Iterator<E> get iterator => _list.iterator;
}
