import 'package:flutter/material.dart';

extension ColorUtils on Color {
  static MaterialColor getMaterialColor({int? intColor, Color? color}) {
    intColor = intColor ?? color?.value;
    return MaterialColor(intColor!, <int, Color>{
      50: Color(intColor),
      100: Color(intColor),
      200: Color(intColor),
      300: Color(intColor),
      400: Color(intColor),
      500: Color(intColor),
      600: Color(intColor),
      700: Color(intColor),
      800: Color(intColor),
      900: Color(intColor),
    });
  }

  MaterialColor asMaterialColor({int? intColor}) {
    return ColorUtils.getMaterialColor(intColor: intColor, color: this);
  }

  Color withDarkness(double factor) {
    int intColor = value;
    int a = (intColor >> 24) & 0xFF;
    int r = (((intColor >> 16) & 0xFF) * factor).toInt();
    int g = (((intColor >> 8) & 0xFF) * factor).toInt();
    int b = ((intColor & 0xFF) * factor).toInt();
    intColor = (a << 24) | (r << 16) | (g << 8) | b;
    return Color(intColor);
  }

  Color get invert => Color((0xFFFFFF - value) | 0xFF000000);
}
