import 'package:adeptutils/src/interfaces/iloader.dart';
import 'package:adeptutils/src/interfaces/item_click_callback.dart';
import 'package:adeptutils/src/interfaces/item_long_click_callback.dart';
import 'package:adeptutils/src/interfaces/click_callback.dart';
import 'package:adeptutils/src/interfaces/long_click_callback.dart';
import 'package:flutter/material.dart';

abstract class IBase<T>
    implements
        ILoader,
        ItemClickCallback<T>,
        ItemLongClickCallback<T>,
        ClickCallback,
        LongClickCallback {
  void setTitle(String title);
  ScaffoldFeatureController<SnackBar, SnackBarClosedReason>? showSnackBar(
    SnackBar snackbar, {
    SnackBarClosedReason? hideCurrent,
    BuildContext? context,
  });
  GlobalKey<ScaffoldState> get scaffoldKey;
  bool get isLoading;
}
