import 'package:collection/collection.dart' show IterableExtension;
import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';

abstract class ILocalize<T> {
  ILocalize.get();

  List<T> get values;

  T? valueOf(String name) =>
      values.firstWhereOrNull((value) => nameOf(value) == name);

  List<String> get valuesAsString => names;

  String nameOf(T value) => describeEnum(value!);

  List<String> get names {
    List<String> namesAsString = [];
    for (var value in values) {
      namesAsString.add(nameOf(value));
    }
    return namesAsString;
  }

  String? locale(T value, {BuildContext? context}) => 'Locale not found';

  List<String> get locales {
    List<String> locales = [];
    for (var value in values) {
      String? localeValue = locale(value);
      if (localeValue != null) locales.add(localeValue);
    }
    return locales;
  }

  String? extended(T value) => 'Extended not found';
}
