import 'dart:async';
import 'package:flutter/material.dart';
import 'package:adeptutils/src/interfaces/ibasic.dart';
import 'package:adeptutils/src/interfaces/ilifecycle_state.dart';

abstract class IWidget<T> extends IBasic<T> implements ILifeCycleState {
  @mustCallSuper
  int getSelectedDrawerItemId();
  bool isPressBackAgain();
  void pressBackAgain(bool pressBackAgain,
      {String pressBackAgainMessage = 'Press back again to exit'});
  void onBuildCompleted();
  Future<bool> onBackPressed();
  void pop<I extends Object?>({BuildContext? context, I? result});
  Future<I?>? push<I extends Object?>(
      {BuildContext? context,
      Route<I>? route,
      String? routeName,
      Widget? widget});
  Future<I?>? pushReplacement<I extends Object?, TO extends Object?>(
      {BuildContext? context,
      Route<I>? newRoute,
      String? newRouteName,
      Widget? newWidget,
      TO? result});
}
