import 'package:flutter/material.dart';

extension LocaleUtils on Locale {
  static const List<String> imperialSystemCountries = [
    'US', // United States
    'GB', // United Kingdom
    'CA', // Canada
    'AI', // Anguila
    'AG', // Antigua & Barbuda
    'BB', // Barbados
    'KY', // Cayman Islands,
    'GU', // Guam
    'GG', // Guernsey
    'GM', // Isle Of Man
    'JE', // Jersey
    'IE', // Ireland
    'PR', // Puerto Rico
    'PR', // Puerto Rico
  ];
  bool get usesMetricSystem => !imperialSystemCountries.contains(countryCode);

  static String? toJson(Locale? locale) => locale?.toLanguageTag();

  static Locale? fromJson(dynamic json) =>
      json is String ? fromLanguageTag(json) : null;

  static Locale? fromLanguageTag(String? languageTag) {
    if (languageTag == null) return null;
    List<String> split = languageTag.split('-');
    switch (split.length) {
      case 1:
        return Locale(split[0]);
      case 2:
        return Locale(split[0], split[1]);
      case 3:
        return Locale.fromSubtags(
          languageCode: split[0],
          scriptCode: split[1],
          countryCode: split[2],
        );
    }
    return null;
  }
}
